=== debian/changelog ===
sfront (0.99-5) unstable; urgency=medium

  * Add debian/salsa-ci.yml.
  * Honor dpkg-buildflags.
  * Add a superficial test.
  * Do not trim Debian changelog.
  * Add Vcs-Git and Vcs-Browser fields.
  * Update Standards-Version.

 -- Santiago Vila <sanvila@debian.org>  Sun, 12 Jan 2025 18:10:00 +0100

sfront (0.99-4) unstable; urgency=medium

  * debian/rules: Create parser.tab.c (and parser.tab.h) before anything else.
    This is a workaround for a Makefile bug where some files requiring
    parser.tab.h to be built lack a proper dependency.

 -- Santiago Vila <sanvila@debian.org>  Sat, 08 Jun 2024 11:00:00 +0200

sfront (0.99-3) unstable; urgency=medium

  * Update Homepage.
  * Trim trailing whitespace.
  * Raise debhelper compat level from 9 to 13.
  * Update standards version to 4.6.1.

 -- Santiago Vila <sanvila@debian.org>  Tue, 13 Dec 2022 23:55:00 +0100

sfront (0.99-2) unstable; urgency=medium

  * Switch to dh.
  * Standards-Version: 3.9.8 (no special changes for this).

 -- Santiago Vila <sanvila@debian.org>  Tue, 10 Jan 2017 18:36:26 +0100

sfront (0.99-1) unstable; urgency=medium

  * New upstream release.
  * Fixed typo in README.Debian.
  * Switch to debhelper version 9.
  * Added hardened build flags, using dpkg-buildflags.
  * Do not reference BSD in common-licenses anymore. Put the full
    copyright notice and license in the copyright file.

 -- Santiago Vila <sanvila@debian.org>  Sun, 18 May 2014 18:35:02 +0200
