=== debian/control ===
Source: sfront
Section: sound
Priority: optional
Maintainer: Santiago Vila <sanvila@debian.org>
Build-Depends: debhelper-compat (= 13), bison
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/sanvila/sfront.git
Vcs-Browser: https://salsa.debian.org/sanvila/sfront
Homepage: https://john-lazzaro.github.io/sa/

Package: sfront
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: make, gcc | c-compiler
Description: MPEG 4 Structured Audio decoder
 Sfront compiles MPEG 4 Structured Audio (MP4-SA) bitstreams into
 efficient C programs that generate audio when executed. It supports
 real-time, low-latency audio input/output, MIDI input from
 soundcards, and Network Musical Performance.
 .
 MP4-SA is a standard for normative algorithmic sound, that combines
 an audio signal processing language (SAOL) with score languages
 (SASL, and the legacy MIDI File Format).
 .
 This package includes the sfront application, the sfront manual and
 "The MPEG-4 Structured Audio Book", a book on sound modeling and
 sequencing using MP4-SA.
