=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_build:
	cd src && $(MAKE) parser.tab.c
	cd src/lib && $(MAKE) CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" \
		LINKLIB="$(LDFLAGS) -lm"
	cd src && $(MAKE) sfront CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" \
		LINKLIB="$(LDFLAGS) -lm"

override_dh_auto_clean:
	rm -f build src/lib/libmaker.o src/lib/libmaker
	cd src && $(MAKE) cleanall
	dh_auto_clean

override_dh_install:
	cd src && $(MAKE) install BINDIR=../debian/sfront/usr/bin
	cp -a lib/* debian/sfront/usr/share/sfront
	cp -a README.HTML index.html sfman book copyright \
		debian/sfront/usr/share/doc/sfront/html
	find debian/sfront -name "._*" | xargs rm -f

override_dh_installexamples:
	dh_installexamples -Xrtime/au examples/*

override_dh_installchangelogs:
	dh_installchangelogs --no-trim

override_dh_installman:
	dh_installman debian/sfront.1

override_dh_compress:
# Do not compress files referenced in the HTML manual or in example makefiles.
	dh_compress -XASYS -Xpsync.c -X.c -X.saol -X.sasl -X.wav -XFDL
